use [EFBlogs]
GO

delete from PostTag
delete from Tags
delete from Posts
delete from Blogs

SET IDENTITY_INSERT Blogs ON

insert into Blogs (BlogID, Name, Owner) values (1, 'ADO.NET team blog', 'Microsoft')
insert into Blogs (BlogID, Name, Owner) values (2, 'EF Design Blog', 'Microsoft')
insert into Blogs (BlogID, Name, Owner) values (3, 'Tim Mallalieu''s Blog', 'Tim Mallalieu')
insert into Blogs (BlogID, Name, Owner) values (4, 'Meta-Me', 'Alex James')
insert into Blogs (BlogID, Name, Owner) values (5, 'Diego Vega''s Blog', 'Diego Vega')
insert into Blogs (BlogID, Name, Owner) values (6, 'system.data.objects dev guy', 'Daniel Simmons')

SET IDENTITY_INSERT Blogs OFF

SET IDENTITY_INSERT Posts ON

-- Posts for Blog 1
insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
1,
1,
'01-26-2009',
'01-26-2009',
'Entity Framework-Enabled Providers Lists',
'I love posting announcements to the blog to let people know about the latest and greatest information about Entity Framework-enabled ADO.NET providers.  Blogs are perfect for announcements like that, but they''re not as handy for providing an overview about the available Entity Framework-enabled providers.

To help customers quickly and easily see what Entity Framework-enabled providers are available, released providers are listed on the main Entity Framework page here.  We also have a separate page that lists all publicly available providers, including pre-released providers here.

We''ll continue to post announcements about provider availability to the team blog.  The corresponding entries will appear on the provider list pages within a couple days, since those changes require more time to format and review.

David Sceppa
ADO.NET Program Manager')

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
2,
1,
'01-12-2009',
'01-12-2009',
'OpenLink Releases Their Virtuoso ADO.NET Entity Framework Provider',
'It is my pleasure to announce that OpenLink Software has released their Virtuoso ADO.NET Entity Framework provider - an ADO.NET 3.5 data provider compatible with Visual Studio 2008 and Entity Frameworks, that provides access to native Virtuoso data (SQL, XML, and RDF) in addition to any Virtuoso Linked Tables from external ODBC and JDBC accessible data sources. Known-compatible external data sources include Oracle (versions 7.x to 11.x), Microsoft SQL Server (6.x to 2005), IBM DB2 , Sybase (4.2 to 12.x+), IBM Informix (5.x to 11.x), Ingres (6.4 to 9.x), Progress (7.x to 10.x), MySQL, PostgreSQL, and Firebird.')

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
3,
1,
'12-17-2009',
'12-17-2009',
'New Entity Framework Documentation Topics',
'We have recently added new topics to the Entity Framework documentation. The new topics address frequently asked questions about working with entity keys and enabling scenarios that require manual editing of an .edmx file. Let us know if you find these topics helpful, or how we could make them more helpful: 

Working with Entity Keys
How to: Create an EntityKey
How to: Add a Defining Query 
How to: Edit Inferred Entity Keys 
How to: Work with Store-Generated Column Values 
How to: Map a GUID Property to a Binary Column 
How to: Define Custom Functions in the Storage Model

Thank you.

The Entity Framework User Education Team')

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
4,
1,
'12-5-2009',
'12-5-2009',
'"Table Splitting": Mapping multiple entity types to the same table.',
'Imagine that you have a table called Products which contains a number of columns holding a large amount of data. For example, images of the product from above, front, and side. For most operations against instances of Products, you do not wish to pull down these large columns.

Or, imagine that you would like to split a table such that some clients get a constrained view of the table, while more sophisticated clients get additional information, such as auditing and other internal fields.

There are several ways with which to accomplish this in the Entity Framework, but one of the more flexible and powerful approaches is not much discussed. In this blog post, I will provide a soup-to-nuts example, from DDL to client code, of how to implement this pattern.')

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
5,
1,
'12-2-2008',
'12-2-2008',
'Migrating from LINQ to SQL to the Entity Framework: Stored Procedures for data retrieval',
'LINQ to SQL supports a wide range of scenarios that involve stored procedure mapping and usage. This also happens to be an area where there is a considerable gap between the features offered by LINQ to SQL and the Entity Framework. In this post, we will look at whats possible and whats not in the Entity Framework in terms of using stored procedures.

Bear in mind that as we evolve the Entity Framework, these scenarios that we outline will become considerably easier. Among the many things we are working on in Entity Framework in .NET 4.0 / Visual Studio 10 includes improved support around Stored Procedures and store functions.')

-- Posts for Blog 2

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
6,
2,
'01-22-2009',
'01-22-2009',
'Customizing Entity Classes in VS 2010',
'When VS 2010 ships it will include some significant improvements to our code generation story for the Entity Framework. The basic idea is to make use of T4  templates for code generation and ship strong integration into the Entity Framework Designer to make the experience of customizing those templates as seamless as  possible. 

Below Sanjay from our Tools team outlines what will be possible once VS 2010 is released.')

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
7,
2,
'01-13-2009',
'01-13-2009',
'Update on Computed Properties',
'A while back I wrote a post that introduced the concept of Computed Properties. Since that time weve had a number of conversations with both customers and internal partners and weve had some new ideas, that have changed our thinking somewhat.  

First off we decided to implement Model Defined Functions, which are significantly more powerful and flexible than Computed Properties, and provide overlapping capabilities. 
Computed Properties on the other hand, would never have been structurally part of the entity, which lead to some tough choices and probable customer confusion: 
Do you always pay the cost of materializing the Computed Property even when it is not required? 
What about if there are lots of Computed Properties on the Entity? 
Today in order to materialize an Entity and it''s properties, computed or otherwise, the Entity Framework needs access to setters. Unfortunately the existence of the Setter, sends an erroneous message that Computed Properties can be altered and persisted. 
Upon further investigation we discovered that Computed Properties didn''t actually address the requirements of Reporting Services, which was one of the original  drivers for Computed Properties. Our original design called for computed properties to operate over an instance of an Entity, and it turned out that Reporting  Services needed computed properties to operate over both an instance and a set of instances. Model Defined Functions on the other hand are flexible enough to  handle both of these scenarios. 
In the future it may be possible to gain all the benefits of computed properties without any of the above issues, by extending our integration of Model Defined  Functions with LINQ so that the [EdmFunction] attribute can be applied to CLR properties too. 

If we did this the first parameter of the specified Model Defined Functions could be mapped to be the CLR type containing the property itself.  This would allow  a Computed Property, backed by a Model Defined Function, to be used in a targeted way in LINQ queries, without any of the illusions that this might somehow be  set-able or structurally part of the entity. 
Given all these points we started to think Computed Properties just werent as important. 

We think our best course of actions in the short term is 1) to focus on supporting Model Defined Functions and 2) ask for your feedback on the relative  importance of Computed Properties given the points listed above.

So what do you think? 

Do Model Defined Functions address most of the scenarios for Computed Properties?

Particularly if in the future we can treat CLR properties as stubs for Model Defined Functions?

As always we are very keen to hear what you think.')

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
8,
2,
'01-07-2009',
'01-07-2009',
'Model Defined Functions',
'Today the Entity Framework, and more specifically the Entity Data Model, have a limited notion of Functions.

We are currently restricted to Function Imports that allow stored procedures to be invoked, and Canonical / Store Functions for database independent and database specific functions respectively.

Now however we want to support functions defined, not just declared, in the EDM (aka. the CSDL). 

An example would be: 

<Function Name="GetAge" ReturnType="Edm.Int32"> 
      <Parameter Name="Person" Type="Model.Person" /> 
      <DefiningExpression> 
            Edm.DateDiff(y, GETDATE(), Person.Birthday) 
      </DefiningExpression> 
</Function>')
 
insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
9,
2,
'12-02-2008',
'12-02-2008',
'Pluralization',
'Unfortunately in the current version of the Entity Framework, which ships in .NET 3.5 SP1, we don''t make any attempt to Singularize or Pluralize names when reverse engineering a model from the database. 

So if, for example, your database has a table called Orders you will get an EntityType called Orders too, which clearly doesn''t make for the most read-able code:

Orders order = new Orders(); //? why not just Order ?

LINQ to SQL does a better job here, because it ships with simple but effective pluralization and singuralization services, that for the most part produces names you would expect.

Unfortunately the lack of a similar feature in the Entity Framework, means that generally the first thing you do after you''ve reverse engineered a model with the Entity Framework is fix-up all the silly names.

Now from the perspective of someone who delivers plenty of Entity Framework demos, this is quite embarrassing!  

But of course the real problem here is that it is time consuming and error prone for all but the most trivial models.')

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
10,
2,
'11-20-2008',
'11-20-2008',
'N-Tier Improvements for Entity Framework',
'The first version of Entity Framework provides convenient ways to load, manipulate and persist objects and relationships. As with many other O/RMs, Entity Framework has a state manager that tracks every change made. Existing objects are typically loaded first from the database, later modified, and finally the changes are saved back to the store. 

Another feature, full graph serialization, makes it very easy for developers to ship around object graphs representing snapshots of the current state of the world, across execution boundaries. 

The next version of Entity Framework will also support Persistence Ignorance. Therefore object graphs can now be made of POCO instances, which WCF now also supports.

Nonetheless, there is a task that belongs in any N-Tier application that still requires a great amount of work for developers using EF:  decoding messages that represent state changes performed by the client, meant to be processed or persisted by the service. 

The major pain point in the first version is the number of intricate steps a program needs to perform in order to setup the state manager in the appropriate state according to the changes encoded in the message. For instance, for any but the simplest scenarios, in order to use the basic graph manipulations APIs in ObjectContext, like AddObject and AttachTo, it is necessary to shred the object graphs contained in the message, which destroys important information about relationships between object instances that therefore has to be kept somewhere else (as an illustration of this approach, see Danny Simmonss EntityBag in Project Perseus).

In addition, given that the message typically contains all the necessary information and that concurrency is usually a concern, the program shouldnt have to re-query the database. Instead, it should be easier to tell the state manager about the original state (that came from the database previously) and about what changes were made.

There are a few approaches to N-Tier that are very popular in the industry. Customers using Entity Framework for the first time often carry the expectation that it will support a similar experience.')

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
11,
2,
'10-27-2008',
'10-27-2008',
'Foreign Keys in the Conceptual and Object Models',
'If you are reading this, you have probably heard by now about the so called impedance mismatch between the relational world and the object world  and there are a number of concepts in the relational database that dont translate easily to corresponding concepts supported by the object oriented paradigm. One of these 
factors that is particularly interesting (and often controversial) is the concept of Foreign Keys and whether or not they belong in your conceptual/object model. FKs are used to represent relationships in the database  but with objects, the natural way to represent relationships is through real references between objects. So as an object relational mapping platform, should a product support one or the other, or both?

I think most will agree that there is tremendous value in supporting relationships in the model as first class references between objects.
What are some of the issues with supporting both foreign keys and references in the same model? We could take a real world example i.e. LINQ to SQL and its foreign key support to look at some of the benefits as well as the downsides to having foreign keys.')
-- Posts for Blog 3
insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
12, 
3, 
'06-24-2008', 
'06-24-2008', 
'First Thing on the EF Design Blog', 
'We just pushed the first piece of content to the EF Design Blog. This one is a "Feature Design" posting about the POCO feature that we are working on for V2. Sometime today we hope to get a quick screen cast of a prototype up. We will actively try and get more content either at the feature definition or design spec level throughout the project lifecycle.')

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
13, 
3, 
'07-18-2008',
'07-18-2008',
'Look Mom... no XML',
'We just wrapped up our first iteration of V2.

We are shooting to get another iteration in before PDC and are still working on how we can get early bits out to customers outside of the rhythms of the CTP''s and such.

One of the nifty things in our first iteration, though, was some of the work that we did around POCO. There is a lot more to be done with POCO, we need to still deliver lazy load, value objects and more. With these bits, however, it is possible to write basic POCO code now. 

For a simple experiment I decided to see if I could use these bits to provide a code-first experience with none of the XML artifacts we have in a typical EF application. The support for doing this without XML artifacts on disk is all implemented via public surface from V1....')

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
14, 
3, 
'07-01-2008',
'07-01-2008',
'The Great Entity Smack down',
'There is a wonderful debate going on right now on the entities wiki. You need only read some of the comments on the front page to see that different people are sharing their perspectives on application architecture, methodologies and patterns. 

For a couple weeks now I have been stewing over a wacky idea that I think the time is right for. I would like to propose that we should create "The Great Entity Smack Down". My thought is that we could go get a bunch of folks that represent different perspectives in the community in a public forum. We put together a fictitious development project (oh let''s say pet shop for grins) and we get representatives of different camps to discuss/debate how they would approach the project. 

I am going to shake the trees here in Redmond to see if we can host the event. I would love to start a discussion on what people think of the idea, what groups should be represented, what the format should be and how we go about doing it. I think hosting it in front of a .NET user group and advertising it fairly broadly to different communities would be an interesting venue. 

Chime in... provide some ideas... let''s get it on.

Tim M')

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
15, 
3, 
'06-24-2008',
'06-24-2008',
'POCO Prototype Video...',
'We just threw up a screencast on the EF design site to complement the POCO feature design notes. This was a prototype that Mirek (one of the developers on the team) has been doing around a full POCO enabled state manager. 

I am hoping that we can get early builds out of some of this work in the next month or so. We are still trying to figure out how to drop early and often outside of the CTP rhythms and are looking at what the ASP.NET team has been doing with their bits.')

-- Posts for Blog 4

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
16, 
4, 
'03-03-2009',
'03-03-2009',
'Tip 3 - Getting started with T4', 
'So if you''ve been reading the Entity Framework Design Blog you will have heard us talk about T4. It is a technology that ships with Visual Studio 2008 (and 2005 as a separate download).

In .NET 4.0 the Entity Framework is leverage T4 to help with Code Generation and Model First scenarios.

In fact T4 is also being used in lots of other MS products now, including ASP.NET MVC and Dynamic Data.

So imagine you want to start using T4 now to get familiar with the technology now. How do you do that?

Its actually pretty simple.')

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
17, 
4, 
'02-26-2009',
'02-26-2009',
'Tip 2 - Entity Framework Books', 
'Question: 

Where do I find in depth books on the Entity Framework?

Answer:

One of the benefits of being on a product team a Microsoft is you get authors who want you to review their books. 

So far to date I''ve have had 3 different authors send me copies of their Entity Framework books. ')

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
18, 
4, 
'02-25-2009',
'02-25-2009',
'Tip 1 - Sorting Relationships in Entity Framework', 
'Question:
One of the questions you often see in the Entity Framework Forums is around sorting related items.

For example imagine if you want to query customers, and return only those that have accounts more than 30 days in arrears, and at the same time retrieve their orders. 

And you need those orders sorted by Order date, so you can see the most recent orders first, which allows you to look for things like suspicious patterns easily.

Answer:
Most of you probably know that the EF can eagerly load a relationship using Include(). For example something like this:

var lateCustomers = from c in ctx.Customers.Include("Orders") 
                    where c.IsMoreThan30DaysInArrears 
                    select c;

But unfortunately this will return each customer''s orders in random order. 

So how do you sort them? Well strictly speaking there is no answer. 

But there are a few little things you can do, like do the include in the select clause:

var lateCustomers = from c in ctx.Customers 
                where c.IsMoreThan30DaysInArrears 
                select new {  
                    Customer = c,  
                    Orders = c.Orders.OrderByDescending( 
                                 o => o.OrderDate 
                             )  
                }; 

What this does is use the standard LINQ semantics to ask for an enumeration of anonymous types, which are made up of two things: the Customer and a sorted copy of the Customer''s Orders. 

The Entity Framework supports this just fine, so problem solved...')

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
19, 
4, 
'01-21-2009',
'01-21-2009',
'LINQ to Objects and Buffer<T>', 
'I was debugging a problem a couple of days ago, when I learned something interesting.

I had some code that looked like this:

foreach(Employee e in manager.Manages) 
{ 
     
}

The manager.Manages property returned a custom implementation of ICollection<Employee> that lazy-loads its data from somewhere when enumerated.

I wanted to change the code to display the managers reports sorted by firstname.

So I tried this:

foreach(Employee e in manager.Manages.OrderBy(r => r.Firstname)) 
{ 
     
} 
Pretty simple you would think. 

Unfortunately, when I did this, it suddenly looked like the manager had no reports at all, which I knew was not the case.

Hmm

So I started to delve into the implementation of the OrderBy() extension method. After some digging I found out that internally it uses a struct called Buffer<T>. 

Why Buffer<T> is used is pretty obvious. In order for the OrderBy() method to do a sort it must have all the values in a buffer somewhere.

When I looked at the implementation of Buffer<T> in reflector I noticed that whenever the Buffer<T> class encounters an IEnumerable<T> that also implements ICollection<T> it has a little optimization, that uses Count and CopyTo(..)to initialize an array with the correct size and take a copy of the data, rather enumerating and re-sizing a target array as needed.

When I thought about this I realized that my little Lazy Loading Collection class would return a Count of 0 until it is enumerated. And because the count was 0, the collection would never actually get enumerated. 

So when I used OrderBy(..) over my collection, I get no results. 

Nasty! 

Solution: I simply triggered a LazyLoad whenever Count is called too.

Moral of the Story: if you want your custom collection classes to play nicely with LINQ operators, you better return the correct Count! ')

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
20, 
4, 
'01-11-2009',
'01-11-2009',
'SaveChanges(false)', 
'Most of the time the Entity Framework (EF) can manage transactions for you. 

Every time you Add an Entity, Delete an Entity, Change an Entity, Create a Relationship or Delete a Relationship in your .NET code, these changes are remembered by the EF, and when you call SaveChanges()these are converted to appropriate native SQL commands and executed in the database in a transaction.

Sometimes however you want to use your own transaction. Situations where this is useful include: 

Working with an object context and attempting to put a message in a message queue within the same transaction. 
Working with two object contexts simultaneously. 
Etc etc etc You get the idea. 
In these situations you want the EF to use an ambient transaction (TransactionScope) but more importantly if something goes wrong outside of the EF, you want to be able to recover.

If you call SaveChanges() or SaveChanges(true),the EF simply assumes that if its work completes okay, everything is okay, so it will discard the changes it has been tracking, and wait for new changes.

Unfortunately though if something goes wrong somewhere else in the transaction, because the EF discarded the changes it was tracking, we cant recover.

This is where SaveChanges(false) and AcceptAllChanges() come in.

SaveChanges(false) tells the EF to execute the necessary database commands, but hold on to the changes, so they can be replayed if necessary.')

-- Posts for Blog 5
insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
21, 
5, 
'02-24-2009',
'02-24-2009',
'Server queries and identity resolution', 
'I answered a Connect issue today that deals with a very common expectation for users of systems like Entity Framework and LINQ to SQL. The issue was something like this:

When I run a query, I expect entities that I have added to the context and that are still not saved but match the predicate of the query to show up in the results.

Reality is that Entity Framework queries are always server queries: all queries, LINQ or Entity SQL based, are translated to the database servers native query language and then evaluated exclusively on the server. 

Note: LINQ to SQL actually relaxes this principle in two ways: 
1. Identity-based queries are resolved against the local identity map. For instance, the following query shall not hit the data store:

var c = context.Customers 
    .Where(c => c.CustomerID == "ALFKI");

2. The outermost projection of the query is evaluated on the client. For instance, the following query will create a server query that projects CustomerID and will invoke a client-side WriteLineAndReturn method as code iterates through results:

var q = context.Customers 
    .Select(c => WriteLineAndReturn(c.CustomerID));
But this does not affect the behavior explained in this post.
In sum, Entity Framework does not include a client-side or hybrid query processor.')

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
22, 
5, 
'02-02-2009',
'02-02-2009',
'EntityDataSource and Bind: What are those square brackets?', 
'This post is about a small issue that I have seen in the forums and that arises often in cases in which EntityDataSource is used in combination with bound controls that use templates, like FormsView or a GridView with template based columns. 

If you can create your page correctly, simply using the different drag & drop features and context menus provided by the design surface. However, in the end, some Bind expressions will get enclosed in square brackets that produce compile or run-time errors, then your code may look like this:

<EditItemTemplate> 
    <asp:DropDownList ID="CategoryDropDownList" runat="server" 
        DataSourceID="CategoryDataSource" 
        DataTextField="CategoryName" 
        DataValueField="CategoryID" 
        SelectedValue=''<%# Bind("[Category.CategoryID]") %>''> 
    </asp:DropDownList> 
</EditItemTemplate> 
This annoyance may keep you blocked until you realize how simple the workaround is: just remove the square brackets! 

People that watched my video here, may have noticed that I had to remove the square brackets manually around minute 8:10. I wish I had blogged about it then, but it wasnt clear at the time I recorded that video that the issue would still be there in the RTM version.

Here is a short explanation:

In order to adapt entity objects that do not have foreign key properties to work better with ASP.NET databinding, we decided to wrap each entity returned with a databinding wrapper object that, among other things, flattens the members of EntityKeys in related entities (for more details on how and why the EntityDataSource returns wrapped entities you can go here).

The name of flattened reference keys are usually composed by the corresponding navigation property, plus the name of the property in the related end. For instance, in a Product, the key of the associated Category, will be exposed as Category.CategoryID. We decided to use dots to delimit the parts of the name because that plays well and is consistent with the use of dots in most programming languages, and also in Eval expressions, like the one used in the following code: 

<ItemTemplate> 
    <asp:Label ID="CategoryLabel" runat="server"  
        Text=''<%# Eval("Category.CategoryName") %>''> 
    </asp:Label> 
</ItemTemplate> 
The problem is that for the particular case of Bind (often used in template based databound controls to perform two-way databinding) the design time component of ASP.NET will catch property names that contain dots, and it will try to escape them by surrounding them with square brackets (leading to ta Bind expression of the form [Categories.CategoryID]). 

Unfortunately, the rest of the ASP.NET components which need to evaluate the binding expression are actually not capable of parsing the square brackets escaping notation (i.e. for DataBinder.Eval() the brackets actually indicate that a lookup in an indexed property is necessary, and there is no indexed property in this case). 

Given that the EntityDataSource in fact exposes property descriptors that contain dots in their names, the escaping is unnecessary. So, next time you find this issue, just remove the square brackets.

The good news is that the issue will be fixed in the next release. 

Hope this helps!')

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
23, 
5, 
'10-09-2008',
'10-09-2008',
'Exposing EDM and database server functions to LINQ', 
'Alex published today a description Colin and I wrote on a new feature the team has been working on for LINQ to Entities. 

Beyond all technicalities, it is a very simple and attribute-based way of exposing any arbitrary server-side function to LINQ. It goes beyond what LINQ to SQL does with SqlMethods and it leverages our metadata system so that you don''t have to specify the full mapping of parameters in the attribute. 

The post itself may be a little boring ;), but the scenarios it enables are quite impressive.

Read more here.')

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
24, 
5, 
'06-03-2008',
'06-03-2008',
'Entity Framework Sample Provider Updated for SP1 Beta', 
'Just to get the news out: The updated version of the Entity Framework Sample Provider that is compatible with .NET 3.5 SP1 Beta is now available in our Code Gallery page. From the description:

The Sample Provider wraps System.Data.SqlClient and demonstrates the new functionality an ADO.NET Provider needs to implement in order to support the ADO.NET Entity Framework

Provider Manifest 
EDM Mapping for Schema Information 
SQL Generation')

-- Posts for Blog 6

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
25, 
6, 
'02-21-2009',
'02-21-2009',
'"Local" Queries', 
'Quite some time ago I wrote a blog post about the fact that EF queries execute at the database rather than locally which means that if you add an object to the context or you modify an object already attached to the context, then a query wont be based on the local data.

Earlier today another blogger called this a disappointing behavior .  Since I hate for the EF to disappoint folks, I thought Id whip up a small extension method to help.')

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
26, 
6, 
'01-08-2009',
'01-08-2009',
'Updated EF FAQ posted', 
'I made a round of updates to the EF FAQ a while back but then had some trouble with the blog software (it doesn''t really like the huge word doc chunks I cut and paste into it) and didn''t get around to fixing things.  This morning I gave it another go and things worked.  So we finally have a few updates.  You can take a look at: http://blogs.msdn.com/dsimmons/pages/entity-framework-faq.aspx

I have a whole queue of topics that I need to add or update on the FAQ and will get to them as soon as I reasonably can, but I''ve been focused on development work for the next release of the EF (which will ship with VS 2010/.net 4.0) and haven''t had the cycles I would have liked to devote to this.  As always, if there''s someone out there who would like to contribute to the FAQ, please let me know.

 - Danny')

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
27, 
6, 
'08-20-2008',
'08-20-2008',
'.Net Rocks podcast about the EF Advisory Council now available for download', 
'If you''re not sick and tired of hearing my voice after all the other .Net Rocks/dnrTV things lately, you might want to check out the latest .Net Rocks podcast at http://www.dotnetrocks.com/default.aspx?showNum=369.  It''s hot off the presses.  Usually .Net Rocks shows are recorded several weeks in advance, but this is one that we recorded just yesterday morning, so I was surprised to see it posted already.  In this show Steven Forte and I spoke with Carl and Richard about the recent EF Advisory Council meeting and some thoughts about the long-term vision/direction for the EF and EDM.

 - Danny')

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
28, 
6, 
'10-27-2008',
'10-27-2008',
'Having fun at PDC', 
'If you are at the PDC this week and you are interested in the Entity Framework or LINQ to SQL, then I''d love to chat with you.  Drop me some email or leave a comment here, and we''ll find some time and place to meet.

If you aren''t at the PDC, then I highly recommend that you check out Tim Mallalieu''s talk about Entity Framework Futures which is scheduled for Tuesday afternoon at 5:15 and should be available online approx. 24 hours later.  There''s a lot of great stuff coming in EF v2, and Tim''s talk should help whet your appetite.  :-)

 - Danny')

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
29, 
6, 
'07-29-2008',
'07-29-2008',
'Part 2 of dnrTV about the Entity Framework now up', 
'Check it out at http://www.dnrtv.com/default.aspx?showNum=118.  In this episdoe we build on the first EF dnrTV by looking at using the EF in a variety of scenarios including ASP.Net web pages with the Entity Data Source Control and with ASP.Net Dynamic Data and web services with ADO.Net Data Services and written by hand using WCF.

 - Danny')

insert into Posts (PostID, BlogBlogID, CreatedDate, ModifiedDate, Title, PostContent) values (
30, 
6, 
'07-14-2008',
'07-14-2008',
'Entity Framework Intro up on dnrTV',
'I recently recorded a couple of dnrTV episodes which give some basic introduction to parts of the Entity Framework.  It''s my hope that these will help people quickly get some ideas about what the EF can do and how to get started using it.  The first episode is up now at: http://www.dnrtv.com/default.aspx?showNum=117

Check it out and let me know what you think.

 - Danny')

SET IDENTITY_INSERT Posts OFF

SET IDENTITY_INSERT Tags ON

insert into Tags (TagID, Name) Values (1, 'Entity Framework')
insert into Tags (TagID, Name) Values (2, 'Education')
insert into Tags (TagID, Name) Values (3, 'Mapping')
insert into Tags (TagID, Name) Values (4, 'NTier')
insert into Tags (TagID, Name) Values (5, 'Providers')
insert into Tags (TagID, Name) Values (6, 'Query')
insert into Tags (TagID, Name) Values (7, 'Tools')

SET IDENTITY_INSERT Tags OFF

insert into PostTag (Posts_PostID, Tags_TagID) Values (1, 5)
insert into PostTag (Posts_PostID, Tags_TagID) Values (1, 1)
insert into PostTag (Posts_PostID, Tags_TagID) Values (2, 5)
insert into PostTag (Posts_PostID, Tags_TagID) Values (2, 1)
insert into PostTag (Posts_PostID, Tags_TagID) Values (3, 2)
insert into PostTag (Posts_PostID, Tags_TagID) Values (4, 3)
insert into PostTag (Posts_PostID, Tags_TagID) Values (5, 1)
insert into PostTag (Posts_PostID, Tags_TagID) Values (6, 7)
insert into PostTag (Posts_PostID, Tags_TagID) Values (7, 3)
insert into PostTag (Posts_PostID, Tags_TagID) Values (8, 3)
insert into PostTag (Posts_PostID, Tags_TagID) Values (9, 7)
insert into PostTag (Posts_PostID, Tags_TagID) Values (10, 4)
insert into PostTag (Posts_PostID, Tags_TagID) Values (11, 3)
insert into PostTag (Posts_PostID, Tags_TagID) Values (12, 1)
insert into PostTag (Posts_PostID, Tags_TagID) Values (13, 1)
insert into PostTag (Posts_PostID, Tags_TagID) Values (14, 1)
insert into PostTag (Posts_PostID, Tags_TagID) Values (15, 1)
insert into PostTag (Posts_PostID, Tags_TagID) Values (16, 7)
insert into PostTag (Posts_PostID, Tags_TagID) Values (17, 2)
insert into PostTag (Posts_PostID, Tags_TagID) Values (18, 1)
insert into PostTag (Posts_PostID, Tags_TagID) Values (19, 6)
insert into PostTag (Posts_PostID, Tags_TagID) Values (20, 1)
insert into PostTag (Posts_PostID, Tags_TagID) Values (21, 6)
insert into PostTag (Posts_PostID, Tags_TagID) Values (22, 1)
insert into PostTag (Posts_PostID, Tags_TagID) Values (23, 6)
insert into PostTag (Posts_PostID, Tags_TagID) Values (24, 5)
insert into PostTag (Posts_PostID, Tags_TagID) Values (25, 6)
insert into PostTag (Posts_PostID, Tags_TagID) Values (26, 2)
insert into PostTag (Posts_PostID, Tags_TagID) Values (27, 2)
insert into PostTag (Posts_PostID, Tags_TagID) Values (28, 1)
insert into PostTag (Posts_PostID, Tags_TagID) Values (29, 2)
insert into PostTag (Posts_PostID, Tags_TagID) Values (29, 1)
insert into PostTag (Posts_PostID, Tags_TagID) Values (30, 2)
insert into PostTag (Posts_PostID, Tags_TagID) Values (30, 1)

