﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BlogModel
{
    public class BlogRepository
    {
        BlogContext _context;

        public BlogRepository(BlogContext context)
        {
            _context = context;
        }

        public IEnumerable<Blog> Blogs
        {
            get
            {
                return _context.Blogs.Include("Posts");
            }
        }

        public IEnumerable<Post> GetPosts(Blog blog)
        {
            _context.Blogs.Attach(blog);
            _context.LoadProperty(blog, b => b.Posts);
            return blog.Posts;
        }

        public string UpdatePost(Post post)
        {
            string result = "Updated!";
            try
            {
                post.Validate();
                _context.Posts.Attach(post);
                _context.ObjectStateManager.ChangeObjectState(post,
                    System.Data.EntityState.Modified);
                _context.SaveChanges();
            }
            catch (Exception e)
            {
                result = e.Message;
            }
            return result;
        }
    }
}
