﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data.Entity;
using BlogModel;
using BlogClient.ServiceReference1;

namespace BlogClient
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        Service1Client _client;

        public MainWindow()
        {
            InitializeComponent();

            _client = new Service1Client();
            this.MainGrid.DataContext = _client.GetBlogs();
        }

        private void UpdateButton_Click(object sender, RoutedEventArgs e)
        {
            Post post = PostList.SelectedItem as Post;
            if (post != null)
            {
                post.CreatedDate = post.CreatedDate.AddDays(2);
                MessageBox.Show(_client.UpdatePost(post));
                this.MainGrid.DataContext = _client.GetBlogs();
            }
        }

        private void BlogList_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Blog blog = BlogList.SelectedItem as Blog;
            if (blog.Posts.Count == 0)
            {
                foreach (Post post in _client.GetPosts(blog))
                {
                    blog.Posts.Add(post);
                }
            }
        }
    }


}