
-- --------------------------------------------------
-- Entity Designer DDL Script for SQL Server 2005, 2008, and Azure
-- --------------------------------------------------
-- Date Created: 02/19/2010 23:08:15
-- Generated from EDMX file: C:\HOLs\Entity Framework\Exercise2\Blog\BlogModel\BlogModel.edmx
-- --------------------------------------------------

SET QUOTED_IDENTIFIER OFF;
GO
USE [EFBlogs];
GO
IF SCHEMA_ID(N'dbo') IS NULL EXECUTE(N'CREATE SCHEMA [dbo]');
GO

-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[FK_BlogPost]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Posts] DROP CONSTRAINT [FK_BlogPost];
GO
IF OBJECT_ID(N'[dbo].[FK_PostTag_Post]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[PostTag] DROP CONSTRAINT [FK_PostTag_Post];
GO
IF OBJECT_ID(N'[dbo].[FK_PostTag_Tag]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[PostTag] DROP CONSTRAINT [FK_PostTag_Tag];
GO

-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[Blogs]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Blogs];
GO
IF OBJECT_ID(N'[dbo].[Posts]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Posts];
GO
IF OBJECT_ID(N'[dbo].[Tags]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Tags];
GO
IF OBJECT_ID(N'[dbo].[PostTag]', 'U') IS NOT NULL
    DROP TABLE [dbo].[PostTag];
GO

-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

-- Creating table 'Blogs'
CREATE TABLE [dbo].[Blogs] (
    [BlogID] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [Owner] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'Posts'
CREATE TABLE [dbo].[Posts] (
    [PostID] int IDENTITY(1,1) NOT NULL,
    [CreatedDate] datetime  NOT NULL,
    [ModifiedDate] datetime  NOT NULL,
    [PostContent] nvarchar(max)  NOT NULL,
    [Title] nvarchar(max)  NOT NULL,
    [BlogBlogID] int  NOT NULL
);
GO

-- Creating table 'Tags'
CREATE TABLE [dbo].[Tags] (
    [TagID] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'PostTag'
CREATE TABLE [dbo].[PostTag] (
    [Posts_PostID] int  NOT NULL,
    [Tags_TagID] int  NOT NULL
);
GO

-- --------------------------------------------------
-- Creating all PRIMARY KEY constraints
-- --------------------------------------------------

-- Creating primary key on [BlogID] in table 'Blogs'
ALTER TABLE [dbo].[Blogs]
ADD CONSTRAINT [PK_Blogs]
    PRIMARY KEY CLUSTERED ([BlogID] ASC);
GO

-- Creating primary key on [PostID] in table 'Posts'
ALTER TABLE [dbo].[Posts]
ADD CONSTRAINT [PK_Posts]
    PRIMARY KEY CLUSTERED ([PostID] ASC);
GO

-- Creating primary key on [TagID] in table 'Tags'
ALTER TABLE [dbo].[Tags]
ADD CONSTRAINT [PK_Tags]
    PRIMARY KEY CLUSTERED ([TagID] ASC);
GO

-- Creating primary key on [Posts_PostID], [Tags_TagID] in table 'PostTag'
ALTER TABLE [dbo].[PostTag]
ADD CONSTRAINT [PK_PostTag]
    PRIMARY KEY NONCLUSTERED ([Posts_PostID], [Tags_TagID] ASC);
GO

-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on [BlogBlogID] in table 'Posts'
ALTER TABLE [dbo].[Posts]
ADD CONSTRAINT [FK_BlogPost]
    FOREIGN KEY ([BlogBlogID])
    REFERENCES [dbo].[Blogs]
        ([BlogID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_BlogPost'
CREATE INDEX [IX_FK_BlogPost]
ON [dbo].[Posts]
    ([BlogBlogID]);
GO

-- Creating foreign key on [Posts_PostID] in table 'PostTag'
ALTER TABLE [dbo].[PostTag]
ADD CONSTRAINT [FK_PostTag_Post]
    FOREIGN KEY ([Posts_PostID])
    REFERENCES [dbo].[Posts]
        ([PostID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;
GO

-- Creating foreign key on [Tags_TagID] in table 'PostTag'
ALTER TABLE [dbo].[PostTag]
ADD CONSTRAINT [FK_PostTag_Tag]
    FOREIGN KEY ([Tags_TagID])
    REFERENCES [dbo].[Tags]
        ([TagID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_PostTag_Tag'
CREATE INDEX [IX_FK_PostTag_Tag]
ON [dbo].[PostTag]
    ([Tags_TagID]);
GO

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------
